diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 50cd463ff..314969c03 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -3,6 +3,8 @@ package net.minecraft.client.gui.hud.component;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.util.ArrayList;
@@ -12,7 +14,21 @@ public class HudComponents {
     private static final Logger LOGGER = LogUtils.getLogger();
 
     public static String DEFAULT_LAYOUT = null;
-    public static final HudComponents INSTANCE = new HudComponents();
+    public static final @Nullable HudComponents INSTANCE = new HudComponents();
+
+    public static final @NotNull HudComponent HOTBAR = register(new HudComponentHotbar("hotbar", new LayoutAbsolute(0.5f, 1.0f, ComponentAnchor.BOTTOM_CENTER)));
+    public static final @NotNull HudComponent CROSSHAIR = register(new HudComponentCrosshair("crosshair", new LayoutAbsolute(0.5f, 0.5f, ComponentAnchor.CENTER)));
+    public static final @NotNull HudComponent HEALTH_BAR = register(new HudComponentHealthBar("health_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
+    //    public static final HudComponent ARMOR_BAR = register(new HudComponentArmorBar("armor_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
+    public static final @NotNull HudComponent VEHICLE_BAR = register(new HudComponentVehicleHealthBar("vehicle_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
+    public static final @NotNull HudComponent OXYGEN_BAR = register(new HudComponentOxygenBar("oxygen_bar", new LayoutSnap(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
+    public static final @NotNull HudComponent FIRE_BAR = register(new HudComponentFireBar("fire_bar", new LayoutSnap(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
+    public static final @NotNull HudComponent ROTATION_LOCK = register(new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
+    public static final @NotNull HudComponent SUBTITLES = register(new HudComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT)));
+    public static final @NotNull HudComponent LOG = register(new HudComponentLog("log", new LayoutAbsolute(1.0f, 0.0f, ComponentAnchor.TOP_RIGHT)));
+    public static final @NotNull HudComponent ARMOR_DURABILITY = register(new HudComponentArmorDurability("armor_durability", new LayoutAbsolute(0.0f, 1.0f, ComponentAnchor.BOTTOM_LEFT)));
+    public static final @NotNull HudComponent HELD_ITEM_COUNT = register(new HudComponentHeldItemCount("held_item_count", new LayoutSnap(HOTBAR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
+    public static final @NotNull HudComponent INFO_OVERLAY = register(new HudComponentInfoOverlay("info_overlay", new LayoutAbsolute(0.0f, 0.0f, ComponentAnchor.TOP_LEFT)));
 
     public static HudComponent register(HudComponent component) {
         INSTANCE.components.add(component);
@@ -21,14 +37,15 @@ public class HudComponents {
     private final List<HudComponent> components = new ArrayList<>();
 
 
+
     private HudComponents() { }
 
     public List<HudComponent> getComponents() {
-        return components;
+        return this.components;
     }
 
     public HudComponent getComponent(String key) {
-        for (HudComponent component : components) {
+        for (HudComponent component : this.components) {
             if (component.getKey().equals(key)) {
                 return component;
             }
@@ -36,9 +53,9 @@ public class HudComponents {
         return null;
     }
 
-    public String toSettingsString() {
+    public @NotNull String toSettingsString() {
         StringBuilder builder = new StringBuilder();
-        for (HudComponent component : components) {
+        for (HudComponent component : this.components) {
             builder.append(component.toSettingsString()).append('|');
         }
         return builder.toString();
@@ -57,18 +74,4 @@ public class HudComponents {
             component.fromSettingsString(componentSettings);
         }
     }
-
-    public static final HudComponent HOTBAR = register(new HudComponentHotbar("hotbar", new LayoutAbsolute(0.5f, 1.0f, ComponentAnchor.BOTTOM_CENTER)));
-    public static final HudComponent CROSSHAIR = register(new HudComponentCrosshair("crosshair", new LayoutAbsolute(0.5f, 0.5f, ComponentAnchor.CENTER)));
-    public static final HudComponent HEALTH_BAR = register(new HudComponentHealthBar("health_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
-//    public static final HudComponent ARMOR_BAR = register(new HudComponentArmorBar("armor_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
-    public static final HudComponent VEHICLE_BAR = register(new HudComponentVehicleHealthBar("vehicle_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
-    public static final HudComponent OXYGEN_BAR = register(new HudComponentOxygenBar("oxygen_bar", new LayoutSnap(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
-    public static final HudComponent FIRE_BAR = register(new HudComponentFireBar("fire_bar", new LayoutSnap(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
-    public static final HudComponent ROTATION_LOCK = register(new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
-    public static final HudComponent SUBTITLES = register(new HudComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT)));
-    public static final HudComponent LOG = register(new HudComponentLog("log", new LayoutAbsolute(1.0f, 0.0f, ComponentAnchor.TOP_RIGHT)));
-    public static final HudComponent ARMOR_DURABILITY = register(new HudComponentArmorDurability("armor_durability", new LayoutAbsolute(0.0f, 1.0f, ComponentAnchor.BOTTOM_LEFT)));
-    public static final HudComponent HELD_ITEM_COUNT = register(new HudComponentHeldItemCount("held_item_count", new LayoutSnap(HOTBAR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
-    public static final HudComponent INFO_OVERLAY = register(new HudComponentInfoOverlay("info_overlay", new LayoutAbsolute(0.0f, 0.0f, ComponentAnchor.TOP_LEFT)));
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
index 95b769d4a..0ce40fc8e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.hud.component.layout;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.hud.component.HudComponent;
+import net.minecraft.client.option.GameSettings;
 
 public class LayoutAbsolute
     extends Layout {
@@ -17,15 +17,15 @@ public class LayoutAbsolute
     }
 
     public float getXPosition() {
-        return xPosition;
+        return this.xPosition;
     }
 
     public float getYPosition() {
-        return yPosition;
+        return this.yPosition;
     }
 
     public ComponentAnchor getAnchor() {
-        return anchor;
+        return this.anchor;
     }
 
     public void setXPosition(float xPosition) {
@@ -42,31 +42,31 @@ public class LayoutAbsolute
 
     @Override
     public int getComponentX(HudComponent component, int xSizeScreen) {
-        int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-        return (int) (xPosition * xSizeScreen) - component.getAnchorX(anchor) + sp;
+        int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
+        return (int) (this.xPosition * xSizeScreen) - component.getAnchorX(this.anchor) + sp;
     }
 
     @Override
     public int getComponentY(HudComponent component, int ySizeScreen) {
-        int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-        return (int) (yPosition * ySizeScreen) - component.getAnchorY(anchor) + sp;
+        int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
+        return (int) (this.yPosition * ySizeScreen) - component.getAnchorY(this.anchor) + sp;
     }
 
     @Override
     public Layout copy() {
-        return new LayoutAbsolute(xPosition, yPosition, anchor);
+        return new LayoutAbsolute(this.xPosition, this.yPosition, this.anchor);
     }
 
     @Override
     public String toSettingsString() {
-        return xPosition + "," + yPosition + "," + anchor.name();
+        return this.xPosition + "," + this.yPosition + "," + this.anchor.name();
     }
 
     @Override
     public void fromSettingsString(String settings) {
         String[] parts = settings.split(",");
-        xPosition = Float.parseFloat(parts[0]);
-        yPosition = Float.parseFloat(parts[1]);
-        anchor = ComponentAnchor.valueOf(parts[2]);
+        this.xPosition = Float.parseFloat(parts[0]);
+        this.yPosition = Float.parseFloat(parts[1]);
+        this.anchor = ComponentAnchor.valueOf(parts[2]);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
index 034cdcbcf..ee443af20 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.hud.component.layout;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.hud.component.HudComponent;
 import net.minecraft.client.gui.hud.component.HudComponents;
+import net.minecraft.client.option.GameSettings;
 
 public class LayoutSnap
     extends Layout {
@@ -18,15 +18,15 @@ public class LayoutSnap
     }
 
     public HudComponent getParent() {
-        return parent;
+        return this.parent;
     }
 
     public ComponentAnchor getParentAnchor() {
-        return parentAnchor;
+        return this.parentAnchor;
     }
 
     public ComponentAnchor getAnchor() {
-        return anchor;
+        return this.anchor;
     }
 
     public void setParent(HudComponent parent) {
@@ -43,41 +43,41 @@ public class LayoutSnap
 
     @Override
     public int getComponentX(HudComponent component, int xSizeScreen) {
-        if (parent == null) {
-            int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-            return (int) (xSizeScreen * parentAnchor.xPosition) - component.getAnchorX(anchor) + sp;
+        if (this.parent == null) {
+            int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
+            return (int) (xSizeScreen * this.parentAnchor.xPosition) - component.getAnchorX(this.anchor) + sp;
         }
-        return parent.getLayout().getComponentX(parent, xSizeScreen) - component.getAnchorX(anchor) + parent.getAnchorX(parentAnchor);
+        return this.parent.getLayout().getComponentX(this.parent, xSizeScreen) - component.getAnchorX(this.anchor) + this.parent.getAnchorX(this.parentAnchor);
     }
 
     @Override
     public int getComponentY( HudComponent component, int ySizeScreen) {
-        if (parent == null) {
-            int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-            return (int) (ySizeScreen * parentAnchor.yPosition) - component.getAnchorY(anchor) + sp;
+        if (this.parent == null) {
+            int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
+            return (int) (ySizeScreen * this.parentAnchor.yPosition) - component.getAnchorY(this.anchor) + sp;
         }
-        return parent.getLayout().getComponentY(parent, ySizeScreen) - component.getAnchorY(anchor) + parent.getAnchorY(parentAnchor);
+        return this.parent.getLayout().getComponentY(this.parent, ySizeScreen) - component.getAnchorY(this.anchor) + this.parent.getAnchorY(this.parentAnchor);
     }
 
     @Override
     public Layout copy() {
-        return new LayoutSnap(parent, parentAnchor, anchor);
+        return new LayoutSnap(this.parent, this.parentAnchor, this.anchor);
     }
 
     @Override
     public String toSettingsString() {
-        return (parent == null ? "null" : parent.getKey()) + "," + parentAnchor.name() + "," + anchor.name();
+        return (this.parent == null ? "null" : this.parent.getKey()) + "," + this.parentAnchor.name() + "," + this.anchor.name();
     }
 
     @Override
     public void fromSettingsString(String settings) {
         String[] parts = settings.split(",");
         if (parts[0].equals("null")) {
-            parent = null;
+            this.parent = null;
         } else {
-            parent = HudComponents.INSTANCE.getComponent(parts[0]);
+            this.parent = HudComponents.INSTANCE.getComponent(parts[0]);
         }
-        parentAnchor = ComponentAnchor.valueOf(parts[1]);
-        anchor = ComponentAnchor.valueOf(parts[2]);
+        this.parentAnchor = ComponentAnchor.valueOf(parts[1]);
+        this.anchor = ComponentAnchor.valueOf(parts[2]);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/OverlayButtonElement.java b/game/client/src/main/java/net/minecraft/client/gui/options/OverlayButtonElement.java
index adcbe7cd4..18db125be 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/OverlayButtonElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/OverlayButtonElement.java
@@ -1,20 +1,16 @@
 package net.minecraft.client.gui.options;
 
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.util.helper.Listener;
 import net.minecraft.core.util.helper.Toggleable;
 import net.minecraft.client.option.Option;
 
 public class OverlayButtonElement<E extends Option<?> & Toggleable> extends ButtonElement implements Listener<ButtonElement>{
-
-	public final GameSettings settings;
 	public final E option;
 	
-	public OverlayButtonElement(GameSettings settings, E option) {
+	public OverlayButtonElement(E option) {
 		super(0, 0, 0, 0, 0, null);
-		
-		this.settings = settings;
+
 		this.option = option;
 		
 		setListener(this);
@@ -24,13 +20,13 @@ public class OverlayButtonElement<E extends Option<?> & Toggleable> extends Butt
 
 	@Override
 	public void listen(ButtonElement e) {
-		option.toggle();
+        this.option.toggle();
 		
 		updateString();
 	}
 	
 	public void updateString() {
-		this.displayString = option.getDisplayString();
+		this.displayString = this.option.getDisplayString();
 	}
 	
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index c1694d823..85ed0f78e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -11,6 +11,7 @@ import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.gui.options.data.OptionsPageRegistry;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -165,7 +166,7 @@ public class ScreenOptions
             component.onClose();
         }
         super.removed();
-        this.mc.gameSettings.saveOptions();
+        GameSettings.saveOptions();
         this.mc.texturePackList.refreshIfReady();
         reloadIfReady();
     }
@@ -222,6 +223,25 @@ public class ScreenOptions
 
     @Override
     public void render(int mx, int my, float renderPartialTicks) {
+        if (Keyboard.isKeyDown(Keyboard.KEY_LMENU) || Keyboard.isKeyDown(Keyboard.KEY_RMENU)) {
+            int wheel = Mouse.getDWheel();
+
+            int size = GameSettings.GUI_SCALE.size();
+            if (wheel > 0 && GameSettings.GUI_SCALE.value != 0) {
+                GameSettings.GUI_SCALE.value += wheel;
+                if (GameSettings.GUI_SCALE.value > size) GameSettings.GUI_SCALE.value = 0;
+                GameSettings.GUI_SCALE.onUpdate();
+                return;
+            } else if (wheel < 0) {
+                if (GameSettings.GUI_SCALE.value == 0) GameSettings.GUI_SCALE.value += size;
+                GameSettings.GUI_SCALE.value += wheel;
+                if (GameSettings.GUI_SCALE.value <= 0) {
+                    GameSettings.GUI_SCALE.value = 1;
+                }
+                GameSettings.GUI_SCALE.onUpdate();
+                return;
+            }
+        }
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
             mx = -1;
             my = -1;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
index 85eeb0735..31b9a0519 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/BooleanOptionComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.SwitchElement;
-import net.minecraft.client.option.Option;
 import net.minecraft.client.option.OptionBoolean;
 import net.minecraft.client.render.window.CursorShape;
 import org.jetbrains.annotations.Nullable;
@@ -19,10 +18,10 @@ public class BooleanOptionComponent
 
     public BooleanOptionComponent(OptionBoolean option, @Nullable String tooltipTranslationKey)
     {
-        super("options." + option.name, null);
+        super("options." + option.id, null);
 
         this.option = option;
-        this.option.addCallback(__ -> onChange());
+        this.option.addOnChangeCallback((mc, __) -> onChange());
         this.button = new SwitchElement(0, 0, 0, 150, 20, this.option.value, "", "");
         this.button.setOn(this.option.value);
         this.button.displayString = this.option.getDisplayStringValue();
@@ -30,8 +29,8 @@ public class BooleanOptionComponent
 
     @Override
     public void resetValue() {
-        option.set(option.getDefaultValue());
-        option.onUpdate();
+        this.option.set(this.option.getDefaultValue());
+        this.option.onUpdate();
         onChange();
     }
 
@@ -42,7 +41,7 @@ public class BooleanOptionComponent
 
     @Override
     public boolean isDefault() {
-        return option.value.equals(option.getDefaultValue());
+        return this.option.value.equals(this.option.getDefaultValue());
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
index dc0a9653e..6afd549ec 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
@@ -8,7 +8,6 @@ import net.minecraft.client.option.OptionEnum;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.command.TextFormatting;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Objects;
@@ -24,9 +23,9 @@ public class DifficultyOptionComponent extends ButtonComponent {
     }
 
     public DifficultyOptionComponent(OptionEnum<Difficulty> difficultyOption, @Nullable String tooltipTranslationKey) {
-        super("options." + difficultyOption.name, tooltipTranslationKey);
+        super("options." + difficultyOption.id, tooltipTranslationKey);
         option = difficultyOption;
-        option.addCallback(__ -> onChanged());
+        option.addOnChangeCallback((mc, __) -> onChanged());
         this.slider = new IntegerSliderElement(0, 0, 0, 150 - 22, 20, option);
         this.lockButton = new ButtonElement(1, 150 - 20, 0, 20, 20, "");
         this.lockButton.setTextures("minecraft:gui/widgets/button/button_locked", "minecraft:gui/widgets/button/button_locked_highlighted", "minecraft:gui/widgets/button/button_locked_disabled");
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
index 085adda56..1260bc80b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
@@ -32,10 +32,10 @@ public class FloatOptionComponent
 
     public FloatOptionComponent(OptionFloat option, float minValue, float maxValue, @Nullable String tooltipTranslationKey)
     {
-        super("options." + option.name, tooltipTranslationKey);
+        super("options." + option.id, tooltipTranslationKey);
 
         this.option = option;
-        this.option.addCallback(__ -> onChanged());
+        this.option.addOnChangeCallback((mc, __) -> onChanged());
         this.slider = new SliderElement(0, 0, 0, 150, 20, this.option.getDisplayStringValue(), this.option.value);
 
         this.minValue = minValue;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
index ea8bd9dd1..3f4001b2f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.OptionRange;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.client.render.window.GameWindowGLFW;
@@ -18,14 +19,14 @@ public class FramerateOptionComponent extends ToggleableOptionComponent<Integer>
     @Override
     protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY)
     {
-        if (mc.gameSettings.enableVsync.value && mc.gameWindow instanceof GameWindowGLFW) {
-        	slider.sliderValue = mc.gameWindow.getFrequency();
+        if (GameSettings.ENABLE_VSYNC.value && mc.gameWindow instanceof GameWindowGLFW) {
+            this.slider.sliderValue = mc.gameWindow.getFrequency();
             onChanged();
-            slider.enabled = false;
+            this.slider.enabled = false;
         }else {
-            slider.sliderValue = option.value;
+            this.slider.sliderValue = this.option.value;
             onChanged();
-            slider.enabled = true;
+            this.slider.enabled = true;
         }
 
         super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
@@ -43,10 +44,10 @@ public class FramerateOptionComponent extends ToggleableOptionComponent<Integer>
     }
     @Override
     public void init(Minecraft mc){
-        slider.sliderValue = option.getValueIndex();
-        if (mc.gameSettings.enableVsync.value && mc.gameWindow instanceof GameWindowGLFW) {
-            slider.sliderValue = mc.gameWindow.getFrequency();
-            slider.enabled = false;
+        this.slider.sliderValue = this.option.getValueIndex();
+        if (GameSettings.ENABLE_VSYNC.value && mc.gameWindow instanceof GameWindowGLFW) {
+            this.slider.sliderValue = mc.gameWindow.getFrequency();
+            this.slider.enabled = false;
         }
         onChanged();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
index 250f06003..1f6f29b22 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
@@ -19,10 +19,10 @@ public class IntegerOptionComponent
 
     public IntegerOptionComponent(OptionInteger option, @Nullable String tooltipTranslationKey)
     {
-        super("options." + option.name, tooltipTranslationKey);
+        super("options." + option.id, tooltipTranslationKey);
 
         this.option = option;
-        this.option.addCallback(__ -> onChanged());
+        this.option.addOnChangeCallback((mc, __) -> onChanged());
         this.button = new ButtonElement(0, 0, 0, 150, 20, this.option.getDisplayString());
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index ae1424cce..d42284651 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.options.ScreenOptions;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
@@ -25,8 +26,6 @@ public class LanguagePackListComponent
     private static final Logger LOGGER = LogUtils.getLogger();
     private static final int BUTTON_HEIGHT = 32;
 
-    private List<Language> languages = null;
-
     private final List<LanguagePackComponent> buttons = new ArrayList<>();
 
     public LanguagePackListComponent() {
@@ -43,9 +42,9 @@ public class LanguagePackListComponent
         this.buttons.clear();
 
         try {
-            this.languages = LanguageSeeker.getAvailableLanguages();
-            for (int i = 0; i < this.languages.size(); i++) {
-                Language language = this.languages.get(i);
+            List<Language> languages = LanguageSeeker.getAvailableLanguages();
+            for (int i = 0; i < languages.size(); i++) {
+                Language language = languages.get(i);
                 this.buttons.add(new LanguagePackComponent(i, language));
             }
         } catch (IOException e) {
@@ -72,7 +71,7 @@ public class LanguagePackListComponent
             LanguagePackComponent button = this.buttons.get(i);
             if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= 3 + i * (BUTTON_HEIGHT + 3) && relativeMouseY <= 3 + i * (BUTTON_HEIGHT + 3) + BUTTON_HEIGHT) {
                 String lang = button.languagePack.getId();
-                mc.gameSettings.language.set(lang);
+                GameSettings.LANGUAGE.set(lang);
                 I18n.getInstance().reload(lang);
                 mc.currentScreen.init();
             }
@@ -108,7 +107,7 @@ public class LanguagePackListComponent
         }
 
         public void render(int x, int y, int width, int mouseX, int mouseY) {
-            if (this.mc.gameSettings.language.value.equals(this.languagePack.getId())) {
+            if (GameSettings.LANGUAGE.value.equals(this.languagePack.getId())) {
                 // Draw background
                 GLRenderer.pushFrame();
                 GLRenderer.setShader(Shaders.COLOR);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
index 130315d36..0a5987247 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.IntegerSliderElement;
 import net.minecraft.client.option.OptionToggleable;
 import net.minecraft.client.render.window.CursorShape;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ToggleableOptionComponent<E>
@@ -11,6 +12,7 @@ public class ToggleableOptionComponent<E>
 {
     protected final OptionToggleable<E> option;
     protected final IntegerSliderElement slider;
+    protected boolean applyOnRelease = false;
 
     public ToggleableOptionComponent(OptionToggleable<E> option)
     {
@@ -19,13 +21,18 @@ public class ToggleableOptionComponent<E>
 
     public ToggleableOptionComponent(OptionToggleable<E> option, @Nullable String tooltipTranslationKey)
     {
-        super("options." + option.name, tooltipTranslationKey);
+        super("options." + option.id, tooltipTranslationKey);
 
         this.option = option;
-        this.option.addCallback(__ -> onChanged());
+        this.option.addOnChangeCallback((mc, __) -> onChanged());
         this.slider = new IntegerSliderElement(0, 0, 0, 150, 20, option);
     }
 
+    public @NotNull ToggleableOptionComponent<E> applyOnRelease() {
+        this.applyOnRelease = true;
+        return this;
+    }
+
     @Override
     public void resetValue() {
         option.set(option.getDefaultValue());
@@ -38,13 +45,17 @@ public class ToggleableOptionComponent<E>
     protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
         this.slider.mouseClicked(mc, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
         onChanged();
-        this.option.onUpdate();
+        if (!applyOnRelease) {
+            this.option.onUpdate();
+        }
     }
 
     @Override
     protected void buttonDragged(int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
         onChanged();
-        this.option.onUpdate();
+        if (!applyOnRelease) {
+            this.option.onUpdate();
+        }
     }
 
     @Override
